                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*version 11: 1st class continuations*/
                     /*-----------------------------------*/
                     /*            environment            */
                     /*-----------------------------------*/

#include <stdio.h>

#include "SlipMain.h"
#include "SlipEnvironment.h"

/*------------------------------ private constants ---------------------------*/

enum { Environment_global_size = 64 };

/*------------------------------ private variables ---------------------------*/

static VEC_type Current_environment;
static VEC_type Current_frame;
static VEC_type Global_frame;

/*------------------------------ public functions ----------------------------*/

VEC_type Environment_Create_Frame(UNS_type Frame_size)
  { if (Frame_size == 0)
      return Main_Empty_Vector;
    return make_VEC(Frame_size); }

UNS_type Environment_Get_Environment_size(NIL_type)
  { return (size_VEC(Current_environment) + 1); }

VEC_type Environment_Get_Environment(NIL_type)
  { return Current_environment; }

VEC_type Environment_Get_Frame(NIL_type)
  { return Current_frame; }

VEC_type Environment_Global_Frame(NIL_type)
  { UNS_type size;
    size = size_VEC(Current_environment);
    if (size == 0)
      return Current_frame;
    return Current_environment[1]; }

EXP_type Environment_Global_Get(UNS_type Scope,
                                UNS_type Offset)                      
  { EXP_type value;
    VEC_type frame;
    frame = Current_environment[Scope];
    value = frame[Offset];
    return value; }

BYT_type Environment_Global_Overflow(UNS_type Size)
  { return (Size >= Environment_global_size); }

NIL_type Environment_Global_Set(UNS_type Scope,
                                UNS_type Offset,
                                EXP_type Value)
  { VEC_type frame;
    frame = Current_environment[Scope];
    frame[Offset] = Value; }

VEC_type Environment_Grow_Environment(NIL_type)
  { UNS_type size,
             index;
    VEC_type environment,
             frame;
    size = size_VEC(Current_environment);
    environment = make_VEC(++size);
    for (index = 1;
         index < size;
         index++)
      { frame = Current_environment[index];
        environment[index] = frame; }
    environment[size] = Current_frame;
    return environment; }

NIL_type Environment_Initialize(NIL_type) 
  { Current_environment = Main_Empty_Vector;
    Global_frame = Current_frame = make_VEC(Environment_global_size);
    Main_Register((REF_type)&Current_environment);
    Main_Register((REF_type)&Current_frame);
    Main_Register((REF_type)&Global_frame); }

EXP_type Environment_Local_Get(UNS_type Offset)
  { return Current_frame[Offset]; }

NIL_type Environment_Local_Set(UNS_type Offset,
                               EXP_type Value)
  { Current_frame[Offset] = Value; }

NIL_type Environment_Rollback(NIL_type)
  { Current_environment = Main_Empty_Vector;
    Current_frame = Global_frame; }

NIL_type Environment_Set_Environment_And_Frame(VEC_type Environment,
                                               VEC_type Frame)
  { Current_environment = Environment;
    Current_frame = Frame; }
