                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*version 11: 1st class continuations*/
                     /*-----------------------------------*/
                     /*              threads              */
                     /*-----------------------------------*/

#include "SlipMain.h"
#include "SlipThread.h"

/*------------------------------ private constants ---------------------------*/

enum { Thread_table_size = 19 };

static const TXT_type TMT_error_string = "too many thread registrations";

/*------------------------------ private variables ---------------------------*/

static THR_type Current_thread;

static CCC_type Thread_table[Thread_table_size];
static UNS_type Thread_counter;

/*------------------------------ public functions ----------------------------*/

NIL_type Thread_Clear(NIL_type)
  { Current_thread = Main_Empty_Thread; }

NIL_type Thread_Initialize(NIL_type)
  { Current_thread = Main_Empty_Thread;
    Thread_counter = 0;
    Main_Register((REF_type)&Current_thread); }

THR_type Thread_Keep(NIL_type)
  { if (marked_THR(Current_thread))
      Current_thread = Clone_of(Current_thread);
    return Current_thread; }

THR_type Thread_Mark(NIL_type)
  { THR_type thread;
    for (thread = Current_thread;
         !is_NUL(thread);
         thread = thread->thr)
      mark_THR(thread); 
    return Current_thread; }

THR_type Thread_Patch(NBR_type Thread_id)
  { if (marked_THR(Current_thread))
      Current_thread = Clone_of(Current_thread);
    Current_thread->tid = Thread_id; 
    return Current_thread; }

THR_type Thread_Peek(NIL_type)
  { return Current_thread; }

THR_type Thread_Poke(NBR_type Thread_id,
                     EXP_type Call_status,
                     UNS_type Size)
  { THR_type thread;
    thread = Current_thread->thr;
    Current_thread = make_THR(Thread_id,
                              thread,
                              Call_status,
                              Size);
    return Current_thread; }
        
THR_type Thread_Pop(NIL_type)
  { THR_type thread;
    thread = Current_thread;
    Current_thread = Current_thread->thr;
    return thread; }

THR_type Thread_Push(NBR_type Thread_id,
                     EXP_type Call_status,
                     UNS_type Size)
  { Current_thread = make_THR(Thread_id,
                              Current_thread,
                              Call_status,
                              Size);
    return Current_thread; }

NBR_type Thread_Register(CCC_type C_function)
  { NBR_type thread_id;
    if (Thread_counter == Thread_table_size)
      Main_Fatal_Error(TMT_error_string);
    Thread_table[Thread_counter] = C_function;
    thread_id = make_NBR(Thread_counter++);
    return thread_id; }

NIL_type Thread_Replace(THR_type Thread)
  { Current_thread = Thread; }

CCC_type Thread_Retrieve(NBR_type Thread_id)
  { UNS_type raw_thread_id;
    raw_thread_id = get_NBR(Thread_id);
    return Thread_table[raw_thread_id]; }

NIL_type Thread_Zap(NIL_type)
  { Current_thread = Current_thread->thr; }
